package daemon

import (
	"git.beejay.kim/tool/service/config"
	"github.com/urfave/cli/v2"
)

var flags = []cli.Flag{
	&cli.PathFlag{
		Name:      "config",
		Usage:     "config file path",
		Required:  true,
		Aliases:   []string{"C"},
		TakesFile: false,
		Action:    config.Load[Configuration],
	},
	&cli.StringFlag{
		Name:        "pid",
		Usage:       "platform ID",
		Required:    true,
		Destination: &pid,
	},
	&cli.StringFlag{
		Name:        "bid",
		Usage:       "broadcaster ID",
		Required:    true,
		Destination: &bid,
	},
	&cli.PathFlag{
		Name:        "record",
		TakesFile:   false,
		Destination: &pathRecord,
	},
	&cli.StringFlag{
		Name:        "player",
		Usage:       "whether we want to watch stream in realtime",
		Destination: &pathPlayer,
	},
}
