package platform

import (
	"errors"
	"google.golang.org/protobuf/proto"
	"net/http"
)

var (
	errorClosed = errors.New("broadcasting has been over")
)

type Platform interface {
	Id() string
	Host() string
	Init(bid string) error
	Connect(chan proto.Message) error
	HLSStream() (*http.Request, error)
}
